Mirror of the gdb-patches mailing list
 help / color / mirror / Atom feed
From: Lancelot SIX via Gdb-patches <gdb-patches@sourceware.org>
To: gdb-patches@sourceware.org
Subject: [PING] [PATCH v4] [PR gdb/27614] gdb-add-index fails on symlinks.
Date: Sun, 9 May 2021 17:45:13 +0100	[thread overview]
Message-ID: <20210509164513.xqbaosv4hbjq2uji@Plymouth> (raw)
In-Reply-To: <20210417171623.3pxtcz5vumenx7fu@Plymouth>

Hi,

Kindly pinging,

Lancelot.

On Sat, Apr 17, 2021 at 06:16:23PM +0100, Lancelot SIX via Gdb-patches wrote:
> Hi,
> 
> Kindly pinging.
> 
> Lancelot.
> 
> On Mon, Mar 29, 2021 at 09:52:24PM +0100, Lancelot SIX wrote:
> > Since V3:
> > 	- Do net rely on GDB's maintenance commands to resolve
> > 	symlinks, revert to using readlink while maximizing portability.
> > 
> > Since V2:
> > 	- Use GDB to follow symlink instead of readlink. Unlike
> > 	readlink, GDB is guaranteed to be available.
> > 
> > Since V1:
> > 	- Replace '&>/dev/null' with '>/dev/null 2>&1'
> > 
> > --
> > 
> > PR 27614 shows that gdb-add-index fails to generate the index when its
> > argument is a symlink.
> > 
> > The following one liner illustrates the reported problem:
> > 
> >         $ echo 'int main(){}'|gcc -g -x c -;ln -s a.out symlink;gdb-add-index symlink
> >         gdb-add-index: No index was created for symlink
> >         gdb-add-index: [Was there no debuginfo? Was there already an index?]
> >         $ ls -l
> >         -rwxr-xr-x 1 25712 Mar 19 23:05 a.out*
> >         -rw------- 1  8277 Mar 19 23:05 a.out.gdb-index
> >         lrwxrwxrwx 1     5 Mar 19 23:05 symlink -> a.out*
> > 
> > GDB generates the .gdb-index file with a name that matches the name of
> > the actual program (a.out.gdb-index here), not the symlink that
> > references it.  The remaining of the script is looking for a file named
> > after the provided argument (would be 'symlink.gdb-index' in our
> > example).
> > 
> > gdb/ChangeLog:
> > 
> > 	PR gdb/27614
> > 	* contrib/gdb-add-index.sh: Fix when called with a symlink as an
> > 	argument.
> > 
> > gdb/testsuite/ChangeLog:
> > 
> > 	PR gdb/27614
> > 	* gdb.dwarf2/gdb-add-index-symlink.exp: New test.
> > ---
> >  gdb/contrib/gdb-add-index.sh                  | 28 +++++++++++
> >  .../gdb.dwarf2/gdb-add-index-symlink.exp      | 47 +++++++++++++++++++
> >  2 files changed, 75 insertions(+)
> >  create mode 100644 gdb/testsuite/gdb.dwarf2/gdb-add-index-symlink.exp
> > 
> > diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
> > index 2ac3fddbf26..734110caa3b 100755
> > --- a/gdb/contrib/gdb-add-index.sh
> > +++ b/gdb/contrib/gdb-add-index.sh
> > @@ -37,6 +37,34 @@ fi
> >  
> >  file="$1"
> >  
> > +if test -L "$file"; then
> > +    if ! command -v readlink >/dev/null 2>&1; then
> > +	echo "$myname: 'readlink' missing.  Failed to follow symlink $1." 1>&2
> > +	exit 1
> > +    fi
> > +
> > +    # Count number of links followed in order to detect loops.
> > +    count=0
> > +    while test -L "$file"; do
> > +	target=$(readlink "$file")
> > +
> > +	case "$target" in
> > +	    /*)
> > +		file="$target"
> > +		;;
> > +	    *)
> > +		file="$(dirname "$file")/$target"
> > +		;;
> > +	esac
> > +
> > +	count="$((count + 1))"
> > +	if test "$count" -gt 10; then
> > +	    echo "$myname: Detected loop while following link $file"
> > +	    exit 1
> > +	fi
> > +    done
> > +fi
> > +
> >  if test ! -r "$file"; then
> >      echo "$myname: unable to access: $file" 1>&2
> >      exit 1
> > diff --git a/gdb/testsuite/gdb.dwarf2/gdb-add-index-symlink.exp b/gdb/testsuite/gdb.dwarf2/gdb-add-index-symlink.exp
> > new file mode 100644
> > index 00000000000..eaeddec0250
> > --- /dev/null
> > +++ b/gdb/testsuite/gdb.dwarf2/gdb-add-index-symlink.exp
> > @@ -0,0 +1,47 @@
> > +# Copyright 2021 Free Software Foundation, Inc.
> > +
> > +# This program is free software; you can redistribute it and/or modify
> > +# it under the terms of the GNU General Public License as published by
> > +# the Free Software Foundation; either version 3 of the License, or
> > +# (at your option) any later version.
> > +#
> > +# This program is distributed in the hope that it will be useful,
> > +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> > +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> > +# GNU General Public License for more details.
> > +#
> > +# You should have received a copy of the GNU General Public License
> > +# along with this program.  If not, see <http://www.gnu.org/licenses/>.
> > +
> > +load_lib dwarf.exp
> > +
> > +# This test can only be run on targets which support DWARF-2.
> > +if {![dwarf2_support]} {
> > +    return 0
> > +}
> > +
> > +standard_testfile main.c
> > +
> > +if { [prepare_for_testing "failed to prepare" "${testfile}" \
> > +	  [list ${srcfile}]] } {
> > +    return -1
> > +}
> > +
> > +set symlink [file dirname $binfile]/symlink
> > +
> > +if { ![file exists $symlink] } {
> > +    file link -symbolic $symlink $binfile
> > +}
> > +
> > +if { [ensure_gdb_index $symlink] == -1 } {
> > +    fail "Unable to call gdb-add-index with a symlink to a symfile"
> > +    return -1
> > +}
> > +
> > +# Ok, we have a copy of $binfile with an index.
> > +# Restart gdb and verify the index was used.
> > +
> > +clean_restart $symlink
> > +gdb_test "mt print objfiles ${testfile}" \
> > +    "(gdb_index|debug_names).*" \
> > +    "index used"
> > -- 
> > 2.30.1
> > 
> 
> -- 
> Lancelot SIX

-- 
Lancelot SIX

  reply	other threads:[~2021-05-09 16:45 UTC|newest]

Thread overview: 5+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-03-29 20:52 Lancelot SIX via Gdb-patches
2021-04-17 17:16 ` Lancelot SIX via Gdb-patches
2021-05-09 16:45   ` Lancelot SIX via Gdb-patches [this message]
2021-05-10  0:14 ` Simon Marchi via Gdb-patches
2021-05-10 22:24   ` Lancelot SIX via Gdb-patches

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210509164513.xqbaosv4hbjq2uji@Plymouth \
    --to=gdb-patches@sourceware.org \
    --cc=lsix@lancelotsix.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox